package org.seasar.remoting.xmlrpc;

import org.aopalliance.intercept.MethodInvocation;
import org.seasar.framework.aop.interceptors.AbstractInterceptor;

import org.apache.xmlrpc.XmlRpcClient;

import java.util.Vector;

public class XmlRpcInterceptor extends AbstractInterceptor {

	private XmlRpcClient client;

	private String componentName;

	public XmlRpcInterceptor(String url) throws Throwable {
		client = new XmlRpcClient(url);
		componentName = getComponentName(url);
	}

	public XmlRpcInterceptor(String url, String ComponentName) throws Throwable {
		client = new XmlRpcClient(url);
		this.componentName = ComponentName;
	}

	public Object invoke(MethodInvocation invocation) throws Throwable {
		String method = componentName + "." + invocation.getMethod().getName();

		Vector params = new Vector();
		Object[] args = invocation.getArguments();
		for (int i = 0; i < args.length; i++) {
			params.add(args[i]);
		}

		return client.execute(method, params);
	}

	private String getComponentName(String url) {
		int index = url.lastIndexOf("/");
		return url.substring(index + 1);
	}

}